# We have to override the new %%install behavior because, well... the kernel is special.
%global __spec_install_pre %{___build_pre}

%define buildup 1
%define buildsmp 0
%define buildpae 1
%define buildbfs 1
%define buildbfspae 1
%define all_x86 i686
%define sublevel 38
%define subrel 7
%define rcrel 
%define kversion 2.6.%{sublevel}
%define rpmversion 2.6.%{sublevel}
%define KVERREL %{version}-%{release}.%{_target_cpu}
%define hdrarch %_target_cpu
%define asmarch x86
%define make_target bzImage
%define kernel_image arch/x86/boot/bzImage
%define buildheaders 1

%ifarch %{all_x86}
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-i?86*.config
%define image_install_path boot
%define signmodules 1
%define asmarch x86
%define hdrarch i386
%endif
%ifarch x86_64
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-x86_64*.config
%define image_install_path boot
%define asmarch x86
%define signmodules 1
%endif

#
# Packages that need to be installed before the kernel is, because the %post
# scripts use them.
#
%define kernel_prereq  module-init-tools udev ccux-geninitramfs v86d

#
# This macro does requires, provides, conflicts, obsoletes for a kernel package.
#       %%kernel_reqprovconf <subpackage>
# It uses any kernel_<subpackage>_conflicts and kernel_<subpackage>_obsoletes
# macros defined above.
#
%define kernel_reqprovconf \
Provides:       kernel = %{version}-%{release}\
Provides:       kernel-%{_target_cpu}%{?1:.%{1}} = %{kversion}-%{release}\
Requires(pre): %{kernel_prereq}\
%{?1:%{expand:%%{?kernel_%{1}_conflicts:Conflicts: %%{kernel_%{1}_conflicts}}}}\
%{?1:%{expand:%%{?kernel_%{1}_obsoletes:Obsoletes: %%{kernel_%{1}_obsoletes}}}}\
%{?1:%{expand:%%{?kernel_%{1}_provides:Provides: %%{kernel_%{1}_provides}}}}\
# We can't let RPM do the dependencies automatic because it'll then pick up\
# a correct but undesirable perl dependency from the module headers which\
# isn't required for the kernel proper to function\
AutoReq: no\
AutoProv: yes\
%{nil}


Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	The kernel (core of the operating system - device drivers etc.)
Name:      	kernel%{?variant}
Version:   	%{kversion}
Release:   	7
BuildArch:	i686
ExclusiveArch:	%{all_x86} x86_64
%kernel_reqprovconf
Provides: 	kernel-%{_target_cpu}%{?variant:.%{variant}} = %{kversion}-%{release}
BuildRoot:      %{_tmppath}/%{name}-buildroot
Requires:       ccux-bootscripts >= 1.3.0 udev >= 1:146
Requires:       ccux-geninitramfs >= 1:0.0.1-1

#
# List the packages used during the kernel build
#
BuildRequires: module-init-tools, patch >= 2.5.4, bash >= 2.03, coreutils, tar
BuildRequires: bzip2, findutils, gzip, m4, perl, make >= 3.78, diffutils, gawk
BuildRequires: gcc >= 3.4.2, binutils >= 2.12
BuildRequires: net-tools
BuildRequires: xmlto, asciidoc

Obsoletes:      fuse
Obsoletes:      ccux-bootsplash <= 1.3.1-2
License: 	GPLv2
URL:		http://www.kernel.org
Group:     	System/Kernel
Source0:	linux-2.6.%{sublevel}%{?subrel:.%{subrel}}%{?rcrel:-rc%{rcrel}}.tar.bz2

Source200:      Makefile.config
Source201:      merge.pl
Source202:      config-BFS
Source203:      config-debug
Source204:      config-generic
Source205:      config-generic-ccux
Source206:      config-i686-PAE
Source207:      config-ia64-generic
Source208:      config-nodebug
Source209:      config-x86_64-generic
Source210:      config-x86-generic

# base patches

# set compile mtune option to generic for optimized builds
Patch4:	 	linux-2.6-x86-tune-generic.patch

# hotfixpatches 

# fbcondecor http://dev.gentoo.org/~spock/projects/fbcondecor/
# rediffed to 2.6.38.1
Patch91002:	fbcondecor-0.9.6-2.6.38.1.patch

# Kernel Colors
# http://lkml.org/lkml/2007/10/5/199
Patch91003:	kernel-colors.patch

# atop 
# http://www.atoptool.nl
Patch7020:	01patch-2.6.37_atopcnt.patch
Patch7021:	02patch-2.6.33_atopacct

# loop-AES v3.6c 2.6.38 patch
# rediffed against linux 2.6.38.5
Patch3000:	loop-AES-v3.6c-2.6.38.5.patch

# powermanagement
Patch9300: 	linux-2.6-wakeups.patch

# aufs2 - advanced multi layered unification filesystem version 2
# http://aufs.sourceforge.net/
Patch9903:     aufs2-2.6.38.2.patch

# PF Patchset
# http://pf.natalenko.name/
Patch9904:	patch-2.6.38-pf8.patch

# diverse fixes

# remove slashes from name of DVB driver for Flexcop/Technisat receiver 
# http://lkml.indiana.edu/hypermail/linux/kernel/1006.0/00137.html
Patch9911:	linux-2.6.34-dvb_fix_flexcop_driver_name.patch

BuildRequires:	module-init-tools

%description
The kernel package contains the Linux kernel (vmlinuz), the core of any
Linux operating system.  The kernel handles the basic functions
of the operating system: memory allocation, process allocation, device
input and output, etc.


%package headers
Summary: 	Header files for the Linux kernel for use by glibc
Group: 		Development/System
Obsoletes: 	linux-libc-headers
Provides: 	linux-libc-headers

%description headers
Kernel-headers includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package.

%package firmware
Summary: Firmware files used by the Linux kernel
Group: Development/System
# This is... complicated.
License: GPL+ and GPLv2+ and MIT and Redistributable, no modification permitted
%if "x%{?variant}" != "x"
Provides: kernel-firmware = %{rpmversion}-%{pkg_release}
%endif
%description firmware
Kernel-firmware includes firmware files required for some devices to
operate.


#
# This macro creates a kernel-<subpackage>-devel package.
#       %%kernel_devel_package <subpackage> <pretty-name>
#
%define kernel_devel_package() \
%package %{?1:%{1}-}devel\
Summary: Development package for building kernel modules to match the %{?2:%{2} }kernel\
Group: System Environment/Kernel\
Provides: kernel%{?1:-%{1}}-devel-%{_target_cpu} = %{version}-%{release}\
Provides: kernel-devel-%{_target_cpu} = %{version}-%{release}%{?1:.%{1}}\
Provides: kernel-devel = %{version}-%{release}%{?1:.%{1}}\
Provides: kernel-devel-uname-r = %{KVERREL}%{?1:.%{1}}\
AutoReqProv: no\
Requires(pre): /usr/bin/find\
%description -n kernel%{?variant}%{?1:-%{1}}-devel\
This package provides kernel headers and makefiles sufficient to build modules\
against the %{?2:%{2} }kernel package.\
%{nil}


#
# This macro creates a kernel-<subpackage> and its -devel and -debuginfo too.
#       %%define variant_summary The Linux kernel compiled for <configuration>
#       %%kernel_variant_package [-n <pretty-name>] <subpackage>
#
%define kernel_variant_package(n:) \
%package %1\
Summary: %{variant_summary}\
Group: System Environment/Kernel\
%kernel_reqprovconf\
%{expand:%%kernel_devel_package %1 %{!?-n:%1}%{?-n:%{-n*}}}\
%{nil}


# First the auxiliary packages of the main kernel package.
%kernel_devel_package

# Now, each variant package.

%define variant_summary The Linux kernel compiled for SMP machines
%kernel_variant_package -n SMP smp
%description smp
This package includes a SMP version of the Linux kernel. It is
required only on machines with two or more CPUs as well as machines with
hyperthreading technology.

Install the kernel-smp package if your machine uses two or more CPUs.


%define variant_summary The Linux kernel compiled for PAE capable machines
%kernel_variant_package PAE
%description PAE
This package includes a version of the Linux kernel with support for up to
64GB of high memory. It requires a CPU with Physical Address Extensions (PAE).
The non-PAE kernel can only address up to 4GB of memory.
Install the kernel-PAE package if your machine has more than 4GB of memory.

%define variant_summary The Linux kernel compiled for PAE capable machines (BFS)
%kernel_variant_package BFS-PAE
%description BFS-PAE
This package includes a version of the Linux kernel with support for up to
64GB of high memory. It requires a CPU with Physical Address Extensions (PAE).
The non-PAE kernel can only address up to 4GB of memory.
Install the kernel-BFS-PAE package if your machine has more than 4GB of memory.

Using Brain Fuck Scheduler instead of CFS.

%define variant_summary The Linux kernel compiled for PAE capable machines
%kernel_variant_package BFS
%description BFS
This package includes a version of the Linux kernel which is using Brain Fuck 
Scheduler instead of CFS.

%prep
%setup -q -n linux-%{kversion}%{?subrel:.%{subrel}}%{?rcrel:-rc%{rcrel}}

%patch4 -p1

# fbcondecor
%patch91002 -p1 

# colored printk output
%patch91003 -p1

# atop extended support
%patch7020 -p1 -b .atop01
%patch7021 -p1 -b .atop02

## Performance tweaks

#loopAES
#rm -f drivers/block/loop.c include/linux/loop.h
%patch3000 -p1

# power management
%patch9300 -p1

#aufs2
%patch9903 -p1

#pf-patchset BFQ, BFS, TuxOnIce
%patch9904 -p1

# diverse fixes
%patch9911 -p1

# prepare kernel configuration(s)
mkdir -p configs

# Drop some files neccessary for config creation from the source dir into the buildroot
cp $RPM_SOURCE_DIR/config-* .
cp %{SOURCE201} .

# Dynamically generate kernel .config files from config-* files
make -f %{SOURCE200} VERSION=%{version} configs


# now run oldconfig over all the config files
for i in *.config
do 
	mv $i .config 
	
	# Check for different must have config options
	if [ ! `cat .config | grep "CONFIG_FB_CON_DECOR=y"` ]; then
	    echo "Missing CONFIG_FB_CON_DECOR in .config"
	    exit 1
	fi

	Arch=`head -1 .config | cut -b 3-`
	make HOSTCC="gcc -m32" ARCH=$Arch oldconfig #> /dev/null
	echo "# $Arch" > configs/$i
	cat .config >> configs/$i 
done

# get rid of unwanted files resulting from patch fuzz
find . \( -name "*.orig" -o -name "*~" \) -exec rm -f {} \; >/dev/null

# we don't want a .config file when building firmware: it just confuses the build system
%define build_firmware \
   mv .config .config.firmware_save \
   make INSTALL_FW_PATH=$RPM_BUILD_ROOT/lib/firmware firmware_install \
   mv .config.firmware_save .config


%build

cp_vmlinux()
{
  eu-strip --remove-comment -o "$2" "$1"
}

BuildKernel() {
    MakeTarget=$1
    KernelImage=$2
    Flavour=$3
    InstallName=${4:-vmlinuz}

    # Pick the right config file for the kernel we're building
    Config=kernel-%{version}-%{_target_cpu}${Flavour:+-${Flavour}}.config
    DevelDir=/usr/src/kernels/%{KVERREL}${Flavour:+.${Flavour}}

    # When the bootable image is just the ELF kernel, strip it.
    # We already copy the unstripped file into the debuginfo package.
    if [ "$KernelImage" = vmlinux ]; then
      CopyKernel=cp_vmlinux
    else
      CopyKernel=cp
    fi

    KernelVer=%{version}-%{release}.%{_target_cpu}${Flavour:+.${Flavour}}
    echo BUILDING A KERNEL FOR ${Flavour} %{_target_cpu}...

    # make sure EXTRAVERSION says what we want it to say
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}.%{_target_cpu}${Flavour:+.${Flavour}}/" Makefile


    # and now to start the build process

    make -s mrproper
    cp configs/$Config .config

    Arch=`head -1 .config | cut -b 3-`
    echo USING ARCH=$Arch

    make -s HOSTCC="gcc -m32" ARCH=$Arch oldconfig > /dev/null
    make -s HOSTCC="gcc -m32" ARCH=$Arch V=1 %{?_smp_mflags} $MakeTarget %{?sparse_mflags}
    make -s HOSTCC="gcc -m32" ARCH=$Arch V=1 %{?_smp_mflags} modules %{?sparse_mflags} || exit 1

    # Start installing the results

    mkdir -p $RPM_BUILD_ROOT/%{image_install_path}
    install -m 644 .config $RPM_BUILD_ROOT/boot/config-$KernelVer
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
#if %{with_dracut}
    # We estimate the size of the initramfs because rpm needs to take this size
    # into consideration when performing disk space calculations. (See bz #530778)
#    dd if=/dev/zero of=$RPM_BUILD_ROOT/boot/initramfs-$KernelVer.img bs=1M count=20
#else
    #dd if=/dev/zero of=$RPM_BUILD_ROOT/boot/initrd-$KernelVer.img bs=1M count=20
#endif
    if [ -f arch/$Arch/boot/zImage.stub ]; then
      cp arch/$Arch/boot/zImage.stub $RPM_BUILD_ROOT/%{image_install_path}/zImage.stub-$KernelVer || :
    fi
    $CopyKernel $KernelImage \
	       $RPM_BUILD_ROOT/%{image_install_path}/$InstallName-$KernelVer
    chmod 755 $RPM_BUILD_ROOT/%{image_install_path}/$InstallName-$KernelVer

    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer
    # Override $(mod-fw) because we don't want it to install any firmware
    # We'll do that ourselves with 'make firmware_install'
    make -s  HOSTCC="gcc -m32" ARCH=$Arch INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer mod-fw=
    make -s  HOSTCC="gcc -m32" ARCH=$Arch INSTALL_MOD_PATH=$RPM_BUILD_ROOT vdso_install KERNELRELEASE=$KernelVer
if grep '^CONFIG_XEN=y$' .config >/dev/null; then
      echo > ldconfig-kernel.conf "\
# This directive teaches ldconfig to search in nosegneg subdirectories
# and cache the DSOs there with extra bit 0 set in their hwcap match
# fields.  In Xen guest kernels, the vDSO tells the dynamic linker to
# search in nosegneg subdirectories and to match this extra hwcap bit
# in the ld.so.cache file.
hwcap 0 nosegneg"
    fi
    if [ ! -s ldconfig-kernel.conf ]; then
      echo > ldconfig-kernel.conf "\
# Placeholder file, no vDSO hwcap entries used in this kernel."
    fi
    %{__install} -D -m 444 ldconfig-kernel.conf \
        $RPM_BUILD_ROOT/etc/ld.so.conf.d/kernel-$KernelVer.conf

    # And save the headers/makefiles etc for building modules against
    #
    # This all looks scary, but the end result is supposed to be:
    # * all arch relevant include/ files
    # * all Makefile/Kconfig files
    # * all script/ files

    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/source
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    (cd $RPM_BUILD_ROOT/lib/modules/$KernelVer ; ln -s build source)
    # dirs for additional modules per module-init-tools, kbuild/modules.txt
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/extra
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/updates
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/weak-updates
    # first copy everything
    cp --parents `find  -type f -name "Makefile*" -o -name "Kconfig*"` $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp Module.symvers $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp System.map $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    if [ -s Module.markers ]; then
      cp Module.markers $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    fi    
    # then drop all but the needed Makefiles/Kconfig files
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Documentation
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cp .config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp -a scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    if [ -d arch/%{_arch}/scripts ]; then
      cp -a arch/%{_arch}/scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch} || :
    fi
    if [ -f arch/%{_arch}/*lds ]; then
      cp -a arch/%{_arch}/*lds $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch}/ || :
    fi
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*.o
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*/*.o
    if [ -d arch/%{asmarch}/include ]; then
      cp -a --parents arch/%{asmarch}/include $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/
    fi
    cp -a include $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    
    # Make sure the Makefile and version.h have a matching timestamp so that
    # external modules can be built
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Makefile $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/version.h
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/.config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/autoconf.h
    # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
    cp $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/.config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/config/auto.conf

    if test -s vmlinux.id; then
      cp vmlinux.id $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/vmlinux.id
    else
      echo >&2 "*** WARNING *** no vmlinux build ID! ***"
    fi

    #
    # save the vmlinux file for kernel debugging into the kernel-debuginfo rpm
    #
#%if "%{_enable_debug_packages}" == "1"
#    mkdir -p $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer
#    cp vmlinux $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer
#%endif

    find $RPM_BUILD_ROOT/lib/modules/$KernelVer -name "*.ko" -type f >modnames

    # mark modules executable so that strip-to-file can strip them
    xargs --no-run-if-empty chmod u+x < modnames

    # Generate a list of modules for block and networking.

    fgrep /drivers/ modnames | xargs --no-run-if-empty nm -upA |
    sed -n 's,^.*/\([^/]*\.ko\):  *U \(.*\)$,\1 \2,p' > drivers.undef

    collect_modules_list()
    {
      sed -r -n -e "s/^([^ ]+) \\.?($2)\$/\\1/p" drivers.undef |
      LC_ALL=C sort -u > $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.$1
    }

    collect_modules_list networking \
                         'register_netdev|ieee80211_register_hw|usbnet_probe|phy_driver_register'
    collect_modules_list block \
                         'ata_scsi_ioctl|scsi_add_host|scsi_add_host_with_dma|blk_init_queue|register_mtd_blktrans|scsi_esp_register|scsi_register_device_handler'
    collect_modules_list drm \
                         'drm_open|drm_init'
    collect_modules_list modesetting \
                         'drm_crtc_init'

    # detect missing or incorrect license tags
    rm -f modinfo
    while read i
    do
      echo -n "${i#$RPM_BUILD_ROOT/lib/modules/$KernelVer/} " >> modinfo
      /sbin/modinfo -l $i >> modinfo
    done < modnames

    egrep -v \
          'GPL( v2)?$|Dual BSD/GPL$|Dual MPL/GPL$|GPL and additional rights$' \
          modinfo && exit 1

    rm -f modinfo modnames

    # remove files that will be auto generated by depmod at rpm -i time
    for i in alias alias.bin ccwmap dep dep.bin ieee1394map inputmap isapnpmap ofmap pcimap seriomap symbols symbols.bin usbmap
    do
      rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.$i
    done

    # Move the devel headers out of the root file system
    mkdir -p $RPM_BUILD_ROOT/usr/src/kernels
    mv $RPM_BUILD_ROOT/lib/modules/$KernelVer/build $RPM_BUILD_ROOT/$DevelDir
    ln -sf ../../..$DevelDir $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
}

###
# DO it...
###

# prepare directories
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/boot

#cd linux-%{kversion}.%{_target_cpu}

%if %{buildup}
BuildKernel %make_target %kernel_image
%endif

%if %{buildsmp}
BuildKernel %make_target %kernel_image smp
%endif

%if %{buildpae}
BuildKernel %make_target %kernel_image PAE
%endif

%if %{buildbfs}
BuildKernel %make_target %kernel_image BFS
%endif

%if %{buildbfspae}
BuildKernel %make_target %kernel_image BFS-PAE
%endif

%install
#cd linux-%{kversion}.%{_target_cpu}

%if %{buildheaders}
# Install kernel headers
make  HOSTCC="gcc -m32" ARCH=%{hdrarch} INSTALL_HDR_PATH=$RPM_BUILD_ROOT/usr headers_install

# Do headers_check but don't die if it fails.
make  HOSTCC="gcc -m32" ARCH=%{hdrarch} INSTALL_HDR_PATH=$RPM_BUILD_ROOT/usr headers_check \
     > hdrwarnings.txt || :
if grep -q exist hdrwarnings.txt; then
   sed s:^$RPM_BUILD_ROOT/usr/include/:: hdrwarnings.txt
   # Temporarily cause a build failure if header inconsistencies.
   # exit 1
fi

find $RPM_BUILD_ROOT/usr/include \
     \( -name .install -o -name .check -o \
        -name ..install.cmd -o -name ..check.cmd \) | xargs rm -f

# glibc provides scsi headers for itself, for now
rm -rf $RPM_BUILD_ROOT/usr/include/scsi
rm -f $RPM_BUILD_ROOT/usr/include/asm*/atomic.h
rm -f $RPM_BUILD_ROOT/usr/include/asm*/io.h
rm -f $RPM_BUILD_ROOT/usr/include/asm*/irq.h
%endif

%{build_firmware}

### pre/post/preun/postun scripts

#
# This macro defines a %%post script for a kernel*-devel package.
#       %%kernel_devel_post <subpackage>
#
%define kernel_devel_post() \
%{expand:%%post %{?1:%{1}-}devel}\

%{nil}

#
# This macro defines a %%posttrans script for a kernel package.
#       %%kernel_variant_posttrans [-v <subpackage>] [-s <s> -r <r>] <mkinitrd-args>
# More text can follow to go at the end of this variant's %%post.
#
%define kernel_variant_posttrans(s:r:v:) \
%{expand:%%posttrans %{?-v*}}\

%{nil}

#
# This macro defines a %%post script for a kernel package and its devel package.
#       %%kernel_variant_post [-v <subpackage>] [-s <s> -r <r>] <mkinitrd-args>
# More text can follow to go at the end of this variant's %%post.
#
%define kernel_variant_post(s:r:v:) \
%{expand:%%kernel_devel_post %{?-v*}}\
%{expand:%%kernel_variant_posttrans %{?-v*}}\
%{expand:%%post %{?-v*}}\
### Refresh module dependencies database\
/sbin/depmod -a -F /boot/System.map-%{KVERREL}%{?-v:.%{-v*}} %{KVERREL}%{?-v:.%{-v*}} >/dev/null 2>&1 ||:\
### Build initramfs\
/usr/sbin/ccux-geninitramfs -k %{KVERREL}%{?-v:.%{-v*}} -f >/dev/null 2>&1 ||:\
### Create symlinks\
ln -sf initramfs-%{KVERREL}%{?-v:.%{-v*}}.cpio.gz /boot/initramfs >/dev/null 2>&1 ||:\
ln -sf System.map-%{KVERREL}%{?-v:.%{-v*}} /boot/System.map >/dev/null 2>&1 ||:\
ln -sf vmlinuz-%{KVERREL}%{?-v:.%{-v*}} /boot/vmlinuz >/dev/null 2>&1 ||:\
%{nil}

#
# This macro defines a %%preun script for a kernel package.
#       %%kernel_variant_preun <subpackage>
#
%define kernel_variant_preun() \
%{expand:%%preun %{?1}}\
rm -rf /boot/initramfs-%{KVERREL}%{?1:.%{1}}.cpio.gz ||:\
%{nil}

%kernel_variant_preun
%kernel_variant_post -s kernel-smp -r kernel

%kernel_variant_preun smp
%kernel_variant_post -v smp

%kernel_variant_preun PAE
%kernel_variant_post -v PAE -s kernel-smp -r kernel-PAE

%kernel_variant_preun BFS
%kernel_variant_post -v BFS -s kernel-smp -r kernel-BFS

%kernel_variant_preun BFS-PAE
%kernel_variant_post -v BFS-PAE -s kernel-smp -r kernel-BFS-PAE

###
### file lists
###

%if %{buildheaders}
%files headers
%defattr(-,root,root)
/usr/include/*
# prevent clash with libdrm package
%exclude /usr/include/drm
%endif

%files firmware
%defattr(-,root,root)
/lib/firmware/*

# This is %{image_install_path} on an arch where that includes ELF files,
# or empty otherwise.
%define elf_image_install_path %{?kernel_image_elf:%{image_install_path}}

#
# This macro defines the %%files sections for a kernel package
# and its devel and debuginfo packages.
#       %%kernel_variant_files [-k vmlinux] [-a <extra-files-glob>] [-e <extra-nonbinary>] <condition> <subpackage>
#
%define kernel_variant_files(a:e:k:) \
%if %{1}\
%{expand:%%files %{?2}}\
%defattr(-,root,root)\
/%{image_install_path}/%{?-k:%{-k*}}%{!?-k:vmlinuz}-%{KVERREL}%{?2:.%{2}}\
/boot/System.map-%{KVERREL}%{?2:.%{2}}\
/boot/config-%{KVERREL}%{?2:.%{2}}\
%{?-a:%{-a*}}\
%dir /lib/modules/%{KVERREL}%{?2:.%{2}}\
/lib/modules/%{KVERREL}%{?2:.%{2}}/kernel\
/lib/modules/%{KVERREL}%{?2:.%{2}}/build\
/lib/modules/%{KVERREL}%{?2:.%{2}}/source\
/lib/modules/%{KVERREL}%{?2:.%{2}}/extra\
/lib/modules/%{KVERREL}%{?2:.%{2}}/updates\
/lib/modules/%{KVERREL}%{?2:.%{2}}/weak-updates\
/lib/modules/%{KVERREL}%{?2:.%{2}}/vdso\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.block\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.networking\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.order\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.*.bin\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.builtin\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.drm\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.modesetting\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.devname\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.softdep\
/etc/ld.so.conf.d/kernel-%{KVERREL}%{?2:.%{2}}.conf\
#%ghost /boot/initramfs-%{KVERREL}%{?2:.%{2}}.cpio.gz\
%{?-e:%{-e*}}\
%{expand:%%files %{?2:%{2}-}devel}\
%defattr(-,root,root)\
%verify(not mtime) /usr/src/kernels/%{KVERREL}%{?2:.%{2}}\
#/usr/src/kernels/%{KVERREL}%{?2:.%{2}}\
%endif\
%{nil}


%kernel_variant_files 1
%kernel_variant_files 0 smp
%kernel_variant_files 1 PAE
%kernel_variant_files 1 BFS
%kernel_variant_files 1 BFS-PAE


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat May 21 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-7
- kernel 2.6.38.7
* Mon May 10 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-6
- kernel 2.6.38.6
- pf patchset 2.6.38-pf8
* Mon May 02 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-5
- kernel 2.6.38.5
- pf patchset 2.6.38-pf7
- loopAES 3.6c
- removed all remains of reiser4 patch
* Mon Apr 25 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-4
- kernel 2.6.38.4
- pf patchset 2.6.38-pf6
* Sat Apr 16 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-3
- kernel 2.6.38.3
- pf patchset 2.6.38-pf4
* Mon Mar 28 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-2
- kernel 2.6.38.2
- pf patchset 2.6.38-pf2
- dropped unionfs in favor of aufs2
* Sun Mar 27 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.38-1
- kernel 2.6.38.1
- pf patchset 2.6.38-pf1
* Tue Mar 08 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.37-4
- kernel 2.6.37.3
- pf patchset 2.6.37.3-pf5
- loopAES 3.6b
* Sun Feb 27 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.37-3
- kernel 2.6.37.2
- pf patchset 2.6.37-pf4
* Sun Feb 20 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.37-2
- kernel 2.6.37.1
- pf patchset 2.6.37-pf3
* Fri Jan 07 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.6.37-1
- kernel 2.6.37
- tuxonice 3.2-rc2, 2.6.37-ck1 (incl bfs 363), bfq  (pf patchset 2.6.37-pf0)
* Fri Dec 10 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.36-5
- kernel 2.6.36.2
- pf patchset 2.6.36-pf3
* Tue Nov 16 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.36-4
- kernel 2.6.36.1
- pf patchset 2.6.36-pf2
- disabled automated per tty task groups patch because of suspected
bad performance impact on certain virtualbox images
- loopAES 3.5b
* Tue Nov 16 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.36-3
- disabled generation of (dummy) initrd image
- added automated per tty task groups patch to improve desktop performance
 in non-BFS kernels
* Sun Nov 09 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.36-2
- unified configuration for all kernel flavours
* Sat Nov 08 2010 Stefan Gottwald <gotti@ccux-linux.de> 2.6.36-1
- kernel 2.6.36
- pf patchset 2.6.36-pf1
- alsa 1.0.23.84 snapshot 
- unionfs 2.5.7
- dropped patches upstream
- experimental package branch
* Sun Oct 03 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.35-4
- kernel 2.6.35.7
- pf patchset 2.6.35-pf10 (rediffed to 2.6.35.7)
- experimental package branch
* Fri Oct 01 2010 Christian Metzen <metzench@ccux-linux.de> 2.6.34-5
- make PHY devices static not modules
- regular package branch
* Wed Sep 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.35-3
- kernel 2.6.35.5
* Fri Aug 27 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.35-2
- kernel 2.6.35.4
- pf patchset 2.6.35-pf6
* Sat Aug 07 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.35-2
- kernel 2.6.35.1
* Sat Aug 07 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.35-1
- kernel 2.6.35
- pf patchset 2.6.35-pf1
- removed compcache patch, now upstream
- experimental package branch
* Wed Aug 04 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.34-4
- added patch to check low order lumpy reclaim properly
* Wed Jul 07 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.34-3
- pf patchset 2.6.34-pf7
- reconfigured radeon and i915 kms support
* Mon Jul 05 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.34-2
- kernel 2.6.34.1
- pf patchset 2.6.34-pf6
* Sun Jun 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.34-1
- kernel 2.6.34
- pf patchset 2.6.34-pf4
- loopAES 3.4a
* Mon Apr 05 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.33-4
- kernel 2.6.33.2
- pf patchset 2.6.33-pf2
* Wed Mar 24 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.33-3
- added patches to avoid problems with NVIDIA chipsets
* Thu Mar 18 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.33-2
- kernel 2.6.33.1
- unionfs 2.5.4
* Thu Feb 25 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.33-1
- kernel 2.6.33
* Tue Feb 23 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-19
- kernel 2.6.32.9
* Sun Feb 21 2010 Stefan Gottwald <gotti@ccux-linux.de> 2.6.32-18
- added patch_swap_notify_core_support_2.6.32.8.diff
- pf patchset 2.6.32.8 - 16 (mainly tuxonice changes)
* Mon Feb 15 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-17
- kernel 2.6.32.8
- pf patchset 2.6.32.8 - 15
* Sat Jan 30 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-16
- kernel 2.6.32.7
- pf patchset 2.6.32.7 - 13
* Mon Jan 25 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-15
- kernel 2.6.32.6
- pf patchset 2.6.32.6 - 11
* Sat Jan 23 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-14
- kernel 2.6.32.5
- pf patchset 2.6.32.5 - 10
* Sat Jan 23 2010 Christian Metzen <metzench@ccux-linux.de> 2.6.32-13
- activate control group support
* Tue Jan 19 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-12
- kernel 2.6.32.4
- pf patchset 2.6.32.4 - 8
- dropped patch #9301 (now upstream)
* Sun Jan 17 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-11
- kernel 2.6.32.3
- pf patchset 2.6.32.3 - 7
* Thu Jan 14 2010 Christian Metzen <metzench@ccux-linux.de> 2.6.32-10
- add patch 9301 to get rtc wakeup working again
* Fri Dec 25 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-9
- reverted lirc patch to 2.6.31 version to fix bug #0043
- pf patchset 2.6.32.2 - 6
* Tue Dec 22 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-8
- kernel 2.6.32.2
* Wed Dec 16 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-7
- kernel 2.6.32.1
- pf patchset 2.6.32.1 - 3
* Sun Dec 13 2009 Stefan Gottwald <gotti@ccux-linux.de> 2.6.32-6
- added pf patchset version 9 (BFQ, CFQ [backport 2.6.32], BFS, TuxOnIce)
- added BFS and BFS-PAE variant
* Wed Dec 03 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-5
- final 2.6.32 release
* Sun Nov 22 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-4
- development branch
- kernel 2.6.32-rc8
* Fri Nov 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-3
- development branch
- kernel 2.6.32-rc7
- added aufs2 support
* Wed Nov 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-2
- development branch
- kernel 2.6.32-rc6
* Mon Oct 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.32-1
- development branch
- kernel 2.6.32-rc5
* Tue Oct 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-10
- kernel 2.6.31.4
- split kernel-headers to separate package / spec
* Sun Oct 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-9
- kernel 2.6.31.1
* Fri Sep 18 2009 Christian Wasem <wasem@ccux-linux.de> 2.6.31-8
- activated sis190 kernel module
* Fri Sep 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-7
- kernel 2.6.31
- reenabled loop-AES support
- added compcache 0.6 support
- reiserfs4 gets some reprieve
* Sun Sep 06 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-6
- kernel 2.6.31-rc9
- most of the spooky inotify problems seem to be gone
- temporarily disabled loop-AES support patch (needs some extra loving care)
- alsa 1.0.21 (disabled oss preclaim, enabled Cirrus Logic HDA support, enabled Intel HDA patch support)
- full atop support is back
* Fri Aug 28 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-5
- kernel 2.6.31-rc8
- disabled CONFIG_SYSFS_DEPRECATED and CONFIG_SYSFS_DEPRECATEDv2
* Sat Aug 22 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-4
- kernel 2.6.31-rc7
* Sat Aug 15 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-3
- kernel 2.6.31-rc6
* Tue Aug 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-2
- kernel 2.6.31-rc5
* Mon Jul 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.31-1
- kernel 2.6.31-rc4
- loop-AES 3.2g
* Mon Jul 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-7
- kernel 2.6.30.3
* Tue Jul 21 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-6
- kernel 2.6.30.2
* Fri Jun 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-5
- mainline kernel
- kernel 2.6.30
- switched to lzma kernel compression 
* Wed Jun 03 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-4
- dev version parallel to 2.6.29 branch
- kernel 2.6.30-rc8
* Wed May 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-9
- kernel 2.6.29.4
* Mon May 18 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-3
- dev version parallel to 2.6.29 branch
- kernel 2.6.30-rc6
* Wed May 13 2009 Christian Metzen <metzench@ccux-linux.de> 2.6.29-8
- disable staging/comedi drivers, seems to cause problems on different platforms 
- enable paravirt support
* Wed May 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-7
- kernel 2.6.29.3 
- alsa 1.0.20 
- fbcondecor 0.9.6 
- thinkpad-acpi 0.23 
- tuxonice 3.0.1 
- aufs2 git 2.6.29 instead of unionfs 2.5.1 
- this will be the last CCux kernel with reiser4 support
* Mon May 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-2
- dev version parallel to 2.6.29 branch
- kernel 2.6.30-rc4
- alsa 1.0.20
- fbcondecor 0.9.6
- tuxonice 3.0.1 
* Mon Apr 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.30-1
- dev version parallel to 2.6.29 branch
- kernel 2.6.30-rc3
* Fri Apr 03 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-6
- kernel 2.6.29.1
* Tue Mar 24 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-5
- kernel 2.6.29
- loopAES 3.2f
- temporarily disabled optional atop patches
* Thu Mar 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-4
- thinkpad-acpi-0.22-20090318-BETA
- tuxonice 20090313
* Fri Mar 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-3
- kernel 2.6.29-rc8
* Wed Mar 11 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-2
- kernel 2.6.29-rc7
* Tue Feb 24 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.29-1
- kernel 2.6.29-rc6
- removed thinkpad-acpi patch (now upstream)
- removed squashfs patch (now upstream)
* Sun Feb 22 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-9
- kernel 2.6.28.7
* Thu Feb 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-8
- kernel 2.6.28.6
* Fri Feb 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-7
- kernel 2.6.28.5
* Thu Feb 12 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-6
- kernel 2.6.28.4
* Tue Feb 03 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-5
- kernel 2.6.28.3
* Sun Jan 25 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-4
- kernel 2.6.28.2
* Mon Jan 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-3
- kernel 2.6.28.1
* Fri Jan 16 2009 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-2
- tuxonice 3.0rc8
- thinkpad-acpi 0.22
* Thu Dec 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.28-1
- kernel 2.6.28
* Thu Dec 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-18
- kernel 2.6.27.10
* Sun Dec 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-17
- kernel 2.6.27.9
* Sun Dec 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-16
- kernel 2.6.27.8
* Sat Nov 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-15
- kernel 2.6.27.7
* Sat Nov 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-14
- kernel 2.6.27.6
- thinkpad-acpi 0.21-20081111
- alsa 1.0.18a
* Sat Nov 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-13
- kernel 2.6.27.5
- loopAES v3.2e 
* Mon Nov 03 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.27-12
- added unionfs
* Sun Oct 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-11
- compiled usb host drivers (ehci, ohci, uhci)  into kernel rather than as modules
- lirc 0.8.4a
* Sun Oct 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-10
- kernel 2.6.27.4
* Sun Oct 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-9
- kernel 2.6.27.3
- thinkpad-acpi-0.21-20081019
* Sun Oct 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-8
- kernel 2.6.27.2
* Sat Oct 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-7
- kernel 2.6.27.1
- ext4 patch -2 
* Fri Oct 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-6
- kernel 2.6.27
* Tue Oct 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-5
- kernel 2.6.27-rc9
* Fri Oct 03 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-4
- kernel 2.6.27-rc8-git5 (includes Intel NV eeprom corruption prevention patches)
- reenabled tuxonice support (thanks Mandriva!)
* Mon Sep 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-3
- kernel 2.6.27-rc8
* Mon Sep 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-2
- kernel 2.6.27-rc7
- reenabled reiser4 support
* Tue Sep 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.27-1
- kernel 2.6.27-rc6
- temp. disabled reiser4 and tuxonice support (no patches)
* Mon Sep 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-10
- kernel 2.6.26.5
* Fri Aug 29 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.26-9
- added rtc-wakeup patch
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-8
- kernel 2.6.26.3
- v4l-dvb patchset for Hauppauge DVB cards 20080626 
* Thu Aug 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-7
- kernel 2.6.26.2
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-6
- kernel 2.6.26.1
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-5
- refined Provides
- alsa driver 1.0.17
- tuxonice 3.0-rc7a
* Wed Jul 23 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.26-4
- added some packages to kernel_prereq
* Sun Jul 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-3
- fixed plain kernel config (accidentally PAE config sneaked in)
- reintroduced target_cpu
* Sat Jul 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-2
- fixed post scriplets (symlinks, initramfs generation)
- fixed preun scriplets (delete old initramfs, so /boot doesn't get cluttered)
- proper separation between different kernel flavor configs
* Mon Jul 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-1
- kernel 2.6.26
* Thu Jul 03 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-15
- kernel 2.6.25.10
* Mon Jun 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-14
- thinkpad-acpi 0.21 20080629
* Mon Jun 30 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.25-13
- remove conflicting CONFIG_RTC from config file
* Wed Jun 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-12
- kernel 2.6.25.9
* Sun Jun 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-11
- kernel 2.6.25.8
- thinkpad-acpi 0.21 20080621
* Tue Jun 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-10
- kernel 2.6.25.7
- alsa 1.0.17rc2
* Tue Jun 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-9
- kernel 2.6.25.6
* Sat Jun 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-8
- kernel 2.6.25.5
- alsa 1.0.17rc1
* Fri May 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-7
- kernel 2.6.25.4
- rediffed lirc patch to 0.8.3
* Sat May 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-6
- kernel 2.6.25.3
* Wed May 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-5
- kernel 2.6.25.2
* Fri May 02 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-4
- kernel 2.6.25.1
- reenabled accidentally disabled reiser4 support
- tuxonice 3.0-rc7
* Thu Apr 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-3
- kernel 2.6.25 final
- temp. disabled skas4, acerhk, ck-optimizations
* Sun Apr 13 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-2
- kernel 2.6.25-rc9
* Wed Mar 26 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-11
- kernel 2.6.24.4
- skas4
* Fri Mar 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-1
- kernel 2.6.25-rc5
* Fri Mar 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-10
- kernel 2.6.24.3
* Fri Jan 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-9
- kernel 2.6.24
- tuxonice 3.0-rc5
* Thu Jan 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-8
- kernel 2.6.24-rc8
- thinkpad-acpi 0.19
- dropped ipw3945 patch, use iwlwifi instead
* Mon Jan 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-7
- kernel 2.6.24-rc7
* Sun Dec 30 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.24-6
- added CONFIG_FB_CON_DECOR check in kernel config
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-5
- kernel 2.6.24-rc6
- added relatime as default mount option
- added mtune=generic for more optimized builds
* Thu Dec 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-4
- kernel 2.6.24-rc5
* Sat Dec 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-3
- revised lirc patch
* Tue Dec 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-2
- kernel 2.6.24-rc4
- tuxonice 3.0-rc3
- integrated lirc drivers
- ondemand now default governor
* Sat Nov 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-1
- Kernel 2.6.24-rc3
- CFS v24
- tuxonice 3.0-rc2
- loopAES 3.2b
- thinkpad-acpi 0.18
* Sat Nov 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-8
- Kernel 2.6.23.8
* Sat Oct 27 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-7
- ccux-geninitramfs integration
* Wed Oct 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-6
- disabled old IDE support in favour of libata
- alsa 1.0.15
* Fri Oct 12 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-5
- kernel 2.6.23.1
- revised reiser4 patch
- tuxonice 3.0-rc1
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-4
- added fbcondecor patch
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-3
- modified kernel colors to 0x02 ( green on black )
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-2
- removed bootsplash
- added kernel colors patch
* Wed Oct 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-1
- Version update
- Kernel 2.6.23
- tuxonice 2.2.10.4 (was: suspend2)
* Sat Sep 29 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-9
- Kernel 2.6.22.9
* Sat Sep 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-8
- Kernel 2.6.22.7
* Sat Sep 01 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-7
- Version update
- Kernel 2.6.22.6
- CFS V20.5
* Thu Aug 30 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-6
- Version update
- Kernel 2.6.22.5
* Tue Aug 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-5
- Version update
- Kernel 2.6.22.4
* Thu Aug 16 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-4
- Version update
- Kernel 2.6.22.3
* Tue Aug 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-3
- Version update
- Kernel 2.6.22.2
* Sat Jul 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-2
- Version update
- Kernel 2.6.22.1
- temporarily dropped skas patch
- uvesafb 0.1rc3
- UDF 2.50
- thinkpad-acpi 
* Mon Jul 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-1
- Version update
- Kernel 2.6.22
- CFS V19
- suspend2 2.2.10.2
- loop-AES 3.2a
* Sat Jul 07 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-6
- Version update
- Kernel 2.6.21.6
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-5
- Version update
- Kernel 2.6.21.5
* Sat Jun 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-4
- Version update
- Kernel 2.6.21.4
- suspend2 2.2.10
* Sun May 27 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-3
- Version update
- Kernel 2.6.21.3
- added Intel timer rounding patch
- added hdaps timer patch
- SIS 900 fix is now upstream - removed patch
* Thu May 03 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-2
- Version update
- Kernel 2.6.21.1
- added SIS 900 fix
* Thu Apr 26 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-1
- Version update
- Kernel 2.6.21
- suspend2-2.2.9.13
- integrated git-version of mac80211 aka devicescape wireless stack
* Sat Apr 07 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-7
- Kernel 2.6.20.6
- loop-AES v3.1f
* Sat Mar 24 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-6
- Kernel 2.6.20.4
- configured LZF compression support from module into kernel
* Wed Mar 14 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-5
- Kernel 2.6.20.3
- configured ESS18xx module support
* Sat Feb 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-4
- configured Macintosh partition support (needed for Mac formated
  Ipods)
- configured Linux Security Modules (LSM)
* Tue Feb 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-3
- Kernel 2.6.20.1
* Sat Feb 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-2
- ck patchset 2.6.20-ck1
- suspend2-2.2.9.7
- acerhk 0.5.35
- skas 2.6.20-v9-pre9
* Sun Feb 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-1
- Kernel 2.6.20
- ck patchset 2.6.20-rc6-ck1
- suspend2 2.2.9.3
* Thu Jan 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-6
- Kernel 2.6.19.2
- added backport of HUAWEI UMTS modem fixes from 2.6.20rc4
* Sat Dec 30 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.19-5
- added kernel headers package
* Sun Dec 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.19-4
- removed unionfs and squashfs patches, added loopAES
* Wed Dec 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-3
- Kernel 2.6.19.1
- cleaned up patches
* Sun Dec 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-2
- (re)added Reiser4 support
- added EFI partition support
* Sun Dec 10 2006 Stefan Gottwald <gotti@ccux-linux.de> 2.6.19-1
- Kernel 2.6.19
- suspend2 2.2.9
- unionfs 2.6.19 patch
- vesafb-tng-1.0-rc2
- skas-2.6.19-rc6-v9-pre9
* Sat Oct 28 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-4
- set FAT_DEFAULT_IOCHARSET to cp1250 (fixes umlauts on fat/ntfs partitions)
* Thu Oct 26 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.18-3
- removed 64G mem config ( including PAE ), seems to cause trouble sometimes
* Mon Oct 22 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-2
- Kernel 2.6.18.1
* Sun Oct 01 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-1
- Kernel 2.6.18
- suspend2 2.2.8
- sqashfs 3.1r2
- unionfs 20060916-2203
- vesafb-tng-1.0-rc2-git-20060629
- skas-fremap-v9-pre9
* Fri Aug 24 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-3
- Kernel 2.6.17.11
- squashfs 3.1
- reiser4 for 2.6.17-3
* Wed Aug 09 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-2
- Kernel 2.6.17.8
* Fri Jul 07 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-1
- Kernel 2.6.17.4
- ck patchset update
* Thu Jun 08 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-6
- Kernel 2.6.16.20
- ck patchset update
* Sat May 13 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-5
- Kernel 2.6.16.14
- patchset updates
- modified kernel config for iptables support, Bug #0000149
* Tue May 02 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-4
- Kernel 2.6.16.12
- removed madwifi, separated into own package
- rewdefined config, added smp support and more
* Tue Apr 18 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-3
- Cleaned specfile
- Added provides for target arch
* Mon Apr 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-2
- added unionfs and reiser4 patches
* Tue Apr 04 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-1
- Version update
- update skas patch
- removed ndiswrapper, will be in seperate package again
- updated squashfs to 3.0
- removed acx patches
* Fri Feb 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-11
- ndiswrapper update to 1.10
* Thu Feb 16 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-10
- Added Gottis new ndiswrapper Patch and Update
- Kernel 2.6.15.4, ck patchset update
* Sat Jan 28 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.15-9
- added modules for CS4231/2, SB16, SB_AWE ISA-Chipsets
- added I2O SCSI Chipset module
* Wed Jan 25 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-8
- minor patchset update
* Thu Jan 19 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-7
- ck Patch update, kernel 2.6.15.1
* Sat Jan 14 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-6
- readded ck patch, fglrx module needs to be patched, added missing .cpu file to devel package
* Thu Jan 12 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-5
- temp ck patch removement
* Wed Jan 11 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-4
- Modified ndiswrapper patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-3
- Readded acx1xx patch
- Readded skas patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-2
- New bootsplash Patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-1
- Removed some patches, ndis update
- removed ipw seperate drivers, now upstream
- removed bluez patch, now upstream?
- removed acx100 patch
* Thu Oct 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-8
- Fixed major Bug in skas Patch
* Thu Oct 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-7
- Patchset updates, activated ndis and other lately added patches in the kernel config
* Thu Oct 06 2005 Stefan Gottwald <gotti@ccux-linux.de> 2.6.13-6
- Activate I2O Raid Device Support, added UML SKAS Patch
- Make the ndiswrapper patch working, it is only a Workaround
* Fri Sep 23 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-5
- Recent Patchset updates
* Sat Sep 17 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-4
- Recent Pactset updates
* Mon Sep 05 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-3
- Patchset update, some finetuning
* Sun Sep 04 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-2
- Switched alsa to fully module
* Sat Sep 03 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-1
- Version update
* Sat Aug 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-11
- Some Patchset updates
* Thu Jul 14 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-10
- Removed latest nv update Patches
* Mon Jul 11 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-9
- Added nv update Patches, new madwifi driver
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-8
- Modified config
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-7
- Modified config
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-6
- Added sk98lin Patch, updated to ck3 / 2.6.12.2
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-5
- Fixed minor Bug, removed rivafb Module from config
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-4
- Added some Requires
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-3
- Removed fbsplash, instead added bootsplash
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-2
- Fixed some minor Bugs
* Mon Jun 27 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-1
- Version update to 2.6.12
- Completely rebuild specfile, added support for different Kernel Archs
